<?
/*
(C) 2004-2013 DatuX - info@datux.nl

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


$LEVEL=10;
include_once("../common.php");
include_once("samba.php");
include_once("samba_ldap.php");
include_once("../form.php");


//Get data
$new_smb_discription = GetGlobalSambaOption("server string");
$new_smb_discription = preg_replace("/^\"/", "", $new_smb_discription);
$new_smb_discription = preg_replace("/\"\$/", "", $new_smb_discription);
$new_smb_workgroup = GetGlobalSambaOption("workgroup");
$new_smb_netbiosname = GetGlobalSambaOption("netbios name");
$new_HomesShareTrashBinEnable = GetSambaConfigSetting("homes","vfs objects");
$new_HomesShareTrashBinMaxFileSize = GetSambaConfigSetting("homes","recycle:maxsize");
//Verander eenheid van bytes naar mb's
$new_HomesShareTrashBinMaxFileSize=$new_HomesShareTrashBinMaxFileSize/1048576;

if($new_HomesShareTrashBinEnable=="recycle")
	$new_HomesShareTrashBinEnable="on";

OverwriteNewVars();

if(strlen($new_smb_discription) > 25)
{
	$errors['new_smb_discription']=(_NamingToLong(25));
}
elseif(isset($new_smb_discription) && strlen($new_smb_discription) < 3)
{
	$errors['new_smb_discription']=(_NoNaming(3));
}
elseif(strlen($new_smb_workgroup) > 15)
{
	$errors['new_smb_workgroup']=(_NamingToLong(15));
}
elseif(strlen($new_smb_workgroup) < 2)
{
	$errors['new_smb_workgroup']=(_NoNaming(2));
}
elseif(strlen($new_smb_netbiosname) < 2)
{
	$errors['new_smb_netbiosname'] = (_NoNaming(2));
}

//Check for input errors
if($new_HomesShareTrashBinEnable=="on" && $new_HomesShareTrashBinMaxFileSize!="" &&  Error_ValidInt($new_HomesShareTrashBinMaxFileSize,0,4096))
	$errors[new_HomesShareTrashBinMaxFileSize]=_TrashBinMaxFileSizeError();

if (!$errors  && $_REQUEST['store'] )
{
	$restart_nmbd=0; //if a value change requeres nmbd to restart
	$restart_smbd=0; //if a value change requeres smbd to restart

	if($new_netlogon == "on")
		WriteSmbConfig("netlogon");
	else
		DelShare("netlogon");

	if($new_homes == "on")
		WriteSmbConfig("homes");
	else
		DelShare("homes");

	if($new_profiles == "on")
	{
		WriteSmbConfig("profiles");
		SetGlobalSambaOption("logon path", "\\\\%L\\profiles\\%U");
	}
	else
	{
		DelShare("profiles");
		SetGlobalSambaOption("logon path", "");
	}

	if($new_printstring == "on")
		WriteSmbConfig("printstring");
	else
		DelShare("printstring");

	if($new_root == "on")
		WriteSmbConfig("root");
	else
		DelShare("root");

	if(GetGlobalSambaOption("server string") != $new_smb_discription)
	{
		SetGlobalSambaOption("server string", $new_smb_discription);
		LogInfo(_Logsavedglobalsmbsettings());
	}

	if(GetGlobalSambaOption("workgroup") != $new_smb_workgroup)
	{
		//workgroup or domain changed
		SetGlobalSambaOption("workgroup", $new_smb_workgroup);
		//LDAP domainname moet nog ingesteld worden
		SetLDAPDomainName($new_smb_workgroup);
		LogInfo(_LogsavednewWorkgroupName("$new_smb_workgroup"));
		$restart_nmbd=1;
	}

	if(GetGlobalSambaOption("netbios name") != $new_smb_netbiosname)
	{
		SetGlobalSambaOption("netbios name", $new_smb_netbiosname);
		LogInfo(_LogsavednewNetbiosName("$new_smb_netbiosname"));
		$restart_nmbd=1;
	}

	//Recycling model
	if($new_HomesShareTrashBinEnable=="on")
		$trashBinEnable="recycle";
	else
		$trashBinEnable="";
	$sharepointConfigHomes=ReadSharepointConfig("homes");
	if($sharepointConfigHomes["vfs objects"] !=$trashBinEnable  || $sharepointConfigHomes["recycle:maxsize"] != $new_HomesShareTrashBinMaxFileSize*1048576)
	{
		ChangeSharepointConfig("homes",array("vfs objects"=>$trashBinEnable,"recycle:maxsize"=>$new_HomesShareTrashBinMaxFileSize*1048576));
		$restart_nmbd=1;
	}

	if($restart_nmbd || $restart_smbd)
	{
		SetLocalSID();
		SvcRestart("nmbd");
	}

	Wizard_Done();
	//Redirect($URI);

}



$enableShareTrashBinMaxFileSize=0;
if($new_HomesShareTrashBinEnable=="on")
	$enableShareTrashBinMaxFileSize=1;

if(!isset($_REQUEST[new_store])) $DefaultShares = ReadShares("1");

Title(_DefaultSambaSettings("$new_filter"));
Head();
FormStart($TITLE);
echo "<table cellpadding=\"0\" cellspacing=\"0\">";
	echo "<tr>";
		echo "<td>";
			echo _Netlogon();
		echo "<td>";
		$defaultsetting = "netlogon";
		if($DefaultShares[$defaultsetting])
		{
			$varname="new_".$defaultsetting;
			$$varname="on";
		}
		InputCheckBox("new_$defaultsetting");
	echo "</tr>";

	echo "<tr>";
		echo "<td>";
			echo _RoaminProfileShareStatus();
		echo "<td>";
		$defaultsetting = "profiles";
		if($DefaultShares[$defaultsetting])
		{
			$varname="new_".$defaultsetting;
			$$varname="on";
		}
		InputCheckBox("new_$defaultsetting");
	echo "</tr>";
	echo "<tr>";
		echo "<td>";
			echo _RootShareStatus();
		echo "<td>";
		$defaultsetting = "root";

		if($DefaultShares[$defaultsetting])
		{
			$varname="new_".$defaultsetting;
			$$varname="on";
		}
		InputCheckBox("new_$defaultsetting");
	echo "</tr>";
	echo "<tr>";
		echo "<td>";
			echo _printerstringShareStatus();
		echo "<td>";
		$defaultsetting = "printstring";

		if($DefaultShares[$defaultsetting])
		{
			$varname="new_".$defaultsetting;
			$$varname="on";
		}
		InputCheckBox("new_$defaultsetting");
	echo "</tr>";
	echo "<tr>";
	echo "<td>";
	echo _SMBServerDiscription();
	echo "</td>";
	echo "<td> ";
	InputText("new_smb_discription", $errors );
	echo "</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td>";
	echo _SMBServerNetbiosName();
	echo "</td>";
	echo "<td> ";
	InputText("new_smb_netbiosname", $errors );
	echo "</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td>";
	echo _SMBServerWorkgroup();
	echo "</td>";
	echo "<td> ";
	InputText("new_smb_workgroup", $errors );
	echo "</td>";
	echo "</tr>";

	//echo "<tr>";
	//echo "<td colspan=2><hr>";
	//echo "</tr>";

	echo "<tr>";
	echo "<td>";
	echo "<h2>"._TrashbinHeader()."</h2>";
	echo "</tr>";

	echo "<tr>";
		echo "<td>";
			echo _HomeShareDir();
		echo "<td>";
		$defaultsetting = "homes";
		if($DefaultShares[$defaultsetting])
		{
			$varname="new_".$defaultsetting;
			$$varname="on";
		}
		InputCheckBox("new_$defaultsetting");
	echo "</tr>";
	echo "<tr>";
	echo "<td>";
	echo _HomesShareTrashBinEnable();
	echo "<td>";
	InputCheckBox("new_HomesShareTrashBinEnable",$errors,'',1);
	echo "</tr>";
	echo "<tr>";
	echo "<td> ";
	echo _HomesShareTrashBinMaxFileSize();
	echo "<td>";
	InputText("new_HomesShareTrashBinMaxFileSize",$errors,'',$enableShareTrashBinMaxFileSize);
	echo "</tr>";
	echo "<tr>";
	echo "<td>";
	if ($_SESSION[wizard])
	{
		Wizard_ButtonNext('store');
 	}
	else
	{
		Button('store', _Save());
	}
	echo "</td>";
	echo "</tr>";
echo "</table>";
FormEnd();

echo "<b>Windows 10 ondersteund geen Primary Domain Controller modus meer. U kunt SYN-3 wel als fileserver blijven gebruiken.</b>";

Foot();
